if table = document.querySelector '.match-editable'
    inputs = table.getElementsByTagName 'input'
    rows = table.children[1].children
    match_total = table.querySelector '.match-total'
    match_avg = table.querySelector '.match-avg'

    w = table.querySelector('tbody tr').getElementsByTagName('input').length
    h = inputs.length / w
    scores = []

    sub = (row) -> rows[row].children[w + 1]
    tot = (row) -> rows[row].children[w + 2]
    num = (s) -> if s == '' or isNaN parseInt s then 0 else parseInt s
    timer = 0

    set_score = (col, row, score) ->
        if score != scores[row * w + col]
            scores[row * w + col] = score
            clearTimeout timer
            timer = setTimeout (-> render row), 50
            true
        else
            false

    render = (dirty_row) ->
        subtotal = 0
        subtotal += scores[dirty_row * w + col] for col in [0...w]
        sub(dirty_row).innerHTML = subtotal

        total = if dirty_row then num tot(dirty_row - 1).innerHTML else 0
        for row in [dirty_row...h]
            total += num sub(row).innerHTML
            tot(row).innerHTML = total

        match_total.innerHTML = total
        match_avg.innerHTML = Math.round(total / inputs.length * 10) / 10

    for input, i in inputs
        scores.push num input.value
        ((col, row) ->
            cell = input.parentNode
            cb = ->
                value = num @.value
                if set_score col, row, value
                    cell.className = cell.className.replace /val-\d+/, 'val-' + value
            input.addEventListener 'change', cb
            input.addEventListener 'keyup', cb
        )(i % w, Math.floor i / w)

    render 0
    table.querySelector('input[value=""]')?.focus()

# notes area grows automatically with each added line
if notes = document.getElementById('notes')
    cb = ->
        @.style.height = 0
        @.style.height = @.scrollHeight + 'px'
    notes.addEventListener 'keyup', cb
    cb.call notes

# color toggling + persistence in local storage
match = document.getElementById 'match'
toggle_color = document.getElementById('toggle-colored')

if 'localStorage' of window and localStorage.getItem 'colored-scores'
    match.classList.add 'colored'
    toggle_color.classList.add 'active'

toggle_color.addEventListener 'click', ->
    @.classList.toggle 'active'
    @.blur()
    match.classList.toggle 'colored'

    if 'localStorage' of window
        if match.classList.contains 'colored'
            localStorage.setItem 'colored-scores', true
        else
            localStorage.removeItem 'colored-scores'
